=== debian/changelog ===
kadnode (2.4.1) stable; urgency=medium

  * peers.txt add transmissionbt.com, libtorrent.org, remove openbittorrent.com
  * Debian, Arch: pid file location changed from /var/run/kadnode.pid to /run/
  * various bug fixes

 -- Moritz Warning <moritzwarning@web.de>  Sun, 24 Nov 2024 00:00:00 +0100

kadnode (2.4.0) stable; urgency=medium

  * fix compilation for mbedtls >=3.0.0
  * fix compilation for miniupnpc >=2.2.8
  * remove old searches after about an hour
  * use lower case Crockford base32 encoding
    * base16 is still accepted for input
  * add traffic statistics and uptime
  * support DHT isolation for private swarms
  * various bug fixes

 -- Moritz Warning <moritzwarning@web.de>  Wed, 06 Nov 2024 00:00:00 +0100

kadnode (2.3.0-1) stable; urgency=medium

  * update dht to 0.26
  * fix resolve peers to IPv6 address
  * ignore sigpipe globally (should fix some crashes)
  * fix ttl value for dns interface reply

 -- Moritz Warning <moritzwarning@web.de>  Mon, 10 Feb 2020 00:00:00 +0100

kadnode (2.2.5-1) stable; urgency=medium

  * replace stale unix socket files on startup
  * add freebsd nss code again, was removed by accident
  * remove linker flags from compile calls
  * fix freebsd nss module crash when no address was found

 -- Moritz Warning <moritzwarning@web.de>  Fri, 24 Aug 2018 03:27:44 +0100
