=== debian/control ===
Source: kadnode
Section: net
Priority: optional
Maintainer: Moritz Warning <moritzwarning@web.de>
Build-Depends: debhelper-compat (= 13), dh-sequence-installnss, libmbedtls-dev, libnatpmp-dev, libminiupnpc-dev
Standards-Version: 4.1.4
Homepage: https://github.com/mwarning/kadnode
Vcs-Git: https://github.com/mwarning/kadnode.git
Vcs-Browser: https://github.com/mwarning/kadnode
Bugs: https://github.com/mwarning/kadnode/issues
Rules-Requires-Root: no

Package: kadnode
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libnss3
Description: decentralized DynDNS alternative
 KadNode is a P2P DNS resolver that intercepts system requests for the
 p2p TLD. The decentralized BitTorrent DHT network is network is used
 to find IP addresses. Domains can be ECC crypto key in hex notations
 or domains that are backed by a Public Key Infrastructure (PKI).
