=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export FEATURES="bob tls cmd lpd dns nss natpmp upnp"

%:
	dh $@
